import { DatabaseSchema } from "./mysql-database-definition";
import * as Knex from 'knex';
export default class ModelBuilder {
    private knex;
    private databaseName;
    constructor(knex: Knex, databaseName: string);
    /**
     * Return a copy of an object but with all keys lower case
     */
    static keysToLower<T>(obj: T): T;
    /**
     * Return the length of a type, eg varchar(255)=>255
     * @param type
     */
    private static getMysqlLength(strType);
    /**
     * Return the length of a type, eg varchar(255)=>varchar
     * @param type
     */
    private static stripMysqlLength(type);
    /**
     * return a select query to list all tables or views from a database
     */
    private listFromDatabase(listType);
    private listViews();
    /**
     * Lists all the tables in current database
     */
    private listTables();
    private columnArrayToDatabaseSchema(colArrMap);
    /**
     * List all columns for a table given table name
     */
    private listColumns(tableName);
    private renderModel(tables);
    renderDatabaseSchema(): Promise<DatabaseSchema>;
    private renderViewModel();
    private renderTableModel();
}
