import * as Knex from "Knex";
/**
 *
 */
export default class TsBuilder {
    mysqlTypes: {
        int: string;
        decimal: string;
        double: string;
        float: string;
        set: string;
        bigint: string;
        longblob: string;
        tinyint: string;
        date: string;
        datetime: string;
        timestamp: string;
        text: string;
        longtext: string;
        mediumtext: string;
        varchar: string;
    };
    settings: {
        singularizeClassNames: boolean;
        defaultClassName: string;
        optionalParameters: boolean;
    };
    private schema;
    constructor();
    init(knex: Knex, dbName: string): Promise<void>;
    private toFilename(name);
    private static normFolder(folder);
    private getTsType(type);
    private buildTypeRow(col);
    renderTableFile(folder: string): void;
    renderViewFile(folder: string): void;
    renderClassFiles(folder: string, searchString?: string): void;
    renderInserter(folder: string): void;
    private renderClasses(tables, folder);
    private static listTables(tables, searchFor?);
    private listTables(searchFor?);
    private listViews(searchFor?);
    private getClassName(tableName);
    private renderTs(tableName, table);
}
